

    'Labrynth2
    'Original program and concept by Ryan Jeffords
    'Program modifications by Carl Gundel

    'load bitmaps
    loadbmp "title", "triad.bmp"
    loadbmp "title2","lab.bmp"
    loadbmp "labroom", "labroom.bmp"
    loadbmp "northWall", "labup.bmp"
    loadbmp "southWall", "labdown.bmp"
    loadbmp "eastWall", "labright.bmp"
    loadbmp "westWall", "lableft.bmp"

    UpperLeftX=64
    UpperLeftY=64
    WindowWidth = 445
    WindowHeight = 324
    open "The Labrynth" for graphics_nsb as #brd
    print #brd, "drawbmp title 0 0";
    print #brd, "flush";

    while seconds < 3
        tm$ = time$()
        while tm$ = time$() : wend
        seconds = seconds + 1
    wend
    seconds = 0

    UpperLeftX=150
    UpperLeftY=150
    WindowWidth=295
    WindowHeight=125
    open "The Labrynth" for graphics_nsb as #brdd
    print #brdd, "drawbmp title2 0 0";
    print #brdd, "flush"

    while seconds < 3
        tm$ = time$()
        while tm$ = time$() : wend
        seconds = seconds + 1
    wend
    seconds = 0

    close #brdd
    close #brd

[Game]
    nomainwin
    UpperLeftX=32
    UpperLeftY=25
    WindowWidth = 550
    WindowHeight = 450
    bmpbutton #lab, "ubttn.bmp", [north], UL, 290, 121
    bmpbutton #lab, "dbttn.bmp", [south], UL, 290, 281
    bmpbutton #lab, "lbttn.bmp", [west], UL, 191, 196
    bmpbutton #lab, "rbttn.bmp", [east], UL, 387, 196
    textbox #lab.highscores, 16, 36, 120, 25
    textbox #lab.names, 6, 76, 145, 25
    textbox #lab.score, 6, 106, 145, 25
    textbox #lab.gamescore, 386, 26, 150, 25
    menu #lab, "Options", "Load Game", [load], "Restart", [restart], "Exit", [exit]
    menu #lab, "Help", "Instructions", [instructions], "About Labrynth", [about]
    open "Labrynth" for graphics_nsb_nf as #lab
    nscore=0
    par=0
    move=0
    print #lab, "fill lightgray"
    print #lab.highscores, "   HIGH SCORE"
    print #lab.gamescore, "Score:  ";par-move
    dim n(72)
    dim s(72)
    dim e(72)
    dim w(72)
    dim o(72) 'On or off
    print #lab, "flush";
    for x=1 to 72    'ensure that before a game is loaded that the player doesn't
        n(x)=0           'make a mess of the matrix
        s(x)=0
        e(x)=0
        w(x)=0
        o(x)=0
    next x
    print #lab, "!trapclose [exit]"
    print #lab, "down"

[lab.inputLoop]
    input aVar$
    goto [lab.inputLoop]

[restart]
    close #lab
    if about=1 then close #dc
    if instruct=1 then close #de
    GAME=0
    goto [Game]

[north]
    if n(location)=0 then goto [lab.inputLoop]
    location=n(location)
    move=move+1
    goto [redraw]

[south]
    if s(location)=0 then goto [lab.inputLoop]
    location=s(location)
    move=move+1
    goto [redraw]

[west]
    if w(location)=0 then goto [lab.inputLoop]
    location=w(location)
    move=move+1
    goto [redraw]

[east]
    if e(location)=0 then goto [lab.inputLoop]
    location=e(location)
    move=move+1
    goto [redraw]

[load]
    if GAME=1 then [lab.inputLoop]
    filedialog "Load A Game", "*.WED", fileName$
    if fileName$="" then [lab.inputLoop]
    open fileName$ for input as #dc
    line input #dc, name$
    line input #dc, nscore
    line input #dc, startr
    line input #dc, endr
    line input #dc, par
    for index=1 to 72
        line input #dc, n
        line input #dc, s
        line input #dc, w
        line input #dc, e
        n(index)=n
        s(index)=s
        e(index)=e
        w(index)=w
    next index
    close #dc
    location=startr
    print #lab.names, name$;
    print #lab.score, nscore;
    GAME=1 'This is to prevent people from loading a game once a game is already loaded
                       'Without this flag you would get a mess when it comes to the map
   goto [redraw]

[exit]
    close #lab
    if about=1 then close #dc
    if instruct=1 then close #de
    GAME=0
    end

[instructions]

    open "instruct.lab" for input as #1
    bytes = lof(#1)
    a$ = input$(#1, bytes)
    close #1

    UpperLeftX=40
    UpperLeftY=60
    WindowWidth = 520
    WindowHeight = 450
    texteditor #dc.text, 10, 10, 490, 370
    button #dc, " OK ", [closeInstruct], UL, 10, 390
    open "Labrynth Instructions" for dialog_modal as #dc
    print #dc, "trapclose [closeInstruct]"
    print #dc.text, a$ ;
    print #dc.text, "!origin 1 1" ;
    goto [lab.inputLoop]

[closeInstruct]
    close #dc
    goto [lab.inputLoop]

[about]

    open "about.lab" for input as #1
    bytes = lof(#1)
    a$ = input$(#1, bytes)
    close #1

    UpperLeftX=40
    UpperLeftY=60
    WindowWidth = 520
    WindowHeight = 450
    texteditor #dc.text, 10, 10, 490, 370
    button #dc, " OK ", [closeAbout], UL, 10, 390
    open "About" for dialog_modal as #dc
    print #dc, "trapclose [closeAbout]"
    print #dc.text, a$ ;
    print #dc.text, "!origin 1 1" ;
    goto [lab.inputLoop]

[closeAbout]
    close #dc
    goto [lab.inputLoop]

[redraw]
    o(location)=1
    gosub [visual]

    'if there is a wall drawing segment, delete it
    if wallSegId = 0 then [wallsFirstTime]
    print #lab, "delsegment "; wallSegId

  [wallsFirstTime]
    if location=endr then [WIN] 'They've won

    'draw a door-less room
    print #lab, "drawbmp labroom 180 140"

    'now draw doors on appropriate walls
    if n(location)<>0 then print #lab, "drawbmp northWall 280 160"
    if s(location)<>0 then print #lab, "drawbmp southWall 280 225"
    if w(location)<>0 then print #lab, "drawbmp westWall 220 190"
    if e(location)<>0 then print #lab, "drawbmp eastWall 340 190"

    print #lab.gamescore, "!cls";
    print #lab.gamescore, "Score:  ";par-move

    'get the current drawing segment id
    print #lab, "segment"
    input #lab, wallSegId

    print #lab, "flush";

    goto [lab.inputLoop]

[WIN]
    close #lab
    GAME=0
    if about=1 then close #dc
    if instruct=1 then close #de
    notice "Congratulations!";chr$(13);"You Made It!";chr$(13);"High Score=";nscore;chr$(13);"Your Score=";par-move
    if nscore >par-move then goto [Game]
    nscore=par-move
    WindowWidth = 545
    WindowHeight = 140
    textbox #hs.hs, 226, 26, 270, 25
    statictext #hs.statictext2, "NEW High Score!", 56, 11, 120, 20
    statictext #hs.statictext3, "Enter your name:", 56, 31, 128, 20
    button #hs, "Okay", [yuppers], UL, 11, 66, 42, 25
    open "High Score" for dialog_modal as #hs

[hs.inputLoop]
    input aVar$
    goto [hs.inputLoop]

[yuppers]
    print #hs.hs, "!contents?"
    input #hs.hs, name$
    nscore=par-move
    close #hs
    REM Resave the labrynth with new highscore
    open fileName$ for output as #dc
    print #dc, name$
    print #dc, nscore
    print #dc, startr
    print #dc, endr
    print #dc, par
    for index=1 to 72
        print #dc, n(index)
        print #dc, s(index)
        print #dc, w(index)
        print #dc, e(index)
    next index
    close #dc
    goto [Game]

[visual]

    'This routine is to draw the map of where you have been.

    'if there is a map drawing segment then delete it
    if mapSegId = 0 then [mapFirstTime]
    print #lab, "delsegment "; mapSegId

  [mapFirstTime]

    print #lab, "color darkblue"
    for mapRow = 0 to 7
      for mapColumn = 1 to 9
        thisLoc = mapRow * 9 + mapColumn
        if o(thisLoc) <> 1 then [skipDraw]
        if location = thisLoc then print #lab, "backcolor red" else print #lab, "backcolor darkblue"
        myX = (mapColumn - 1) * 6 + 3
        myY = mapRow * 6 + 308
        print #lab, "place "; myX; " "; myY
        print #lab, "boxfilled "; myX + 4; " "; myY + 4
      [skipDraw]
      next mapColumn
    next mapRow

    'get the current drawing segment id
    print #lab, "segment"
    input #lab, mapSegId

    print #lab, "flush";

  return
